package com.example.launcheractivity;

import java.lang.reflect.Type;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Date;
import java.util.List;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import android.app.Activity;
import android.os.Bundle;
import android.util.Log;

import com.example.launcheractivity.model.Account;
import com.example.launcheractivity.model.AccountObject;
import com.example.launcheractivity.model.AccountObject.MemberObject;
import com.example.launcheractivity.model.Member;
import com.google.gson.Gson;
import com.google.gson.reflect.TypeToken;

public class MainActivity extends Activity {

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_main);
		
		// 生成account对象
		SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd hh:mm:ss");
		Account account = new Account("1", "123456", "传说之美", sdf.format(new Date()));
		
		// 利用gson对象生成json字符串
		Gson gson = new Gson();
		String jsonString = gson.toJson(account);
		Log.i("", jsonString);
		
		// 利用gson解析json字符串为单个对象
		Account account1 = gson.fromJson(jsonString, Account.class);
		Log.i("", account1.toString());
		
		
		// 生成json数组
		Account account2 = new Account("2", "123456", "传说", sdf.format(new Date()));
		Account account3 = new Account("2", "123456", "之美", sdf.format(new Date()));
		List<Account> accountList = new ArrayList<Account>();
		accountList.add(account2);
		accountList.add(account3);
		
		
		JSONArray accountArray = new JSONArray();
		for (int i = 0; i < accountList.size(); i++) {
			String accountStr = gson.toJson(accountList.get(i));
			JSONObject accountObject;
			try {
				accountObject = new JSONObject(accountStr);
				accountArray.put(i, accountObject);
			} catch (JSONException e) {
				e.printStackTrace();
			}
		}
		Log.i("", accountArray.toString());
		
		// 解析json数组
		List<Account> accountList2 = new ArrayList<Account>();
		for(int i=0;i<accountArray.length(); i++){
			JSONObject jsonObject = null;
			try {
				jsonObject = accountArray.getJSONObject(i);
			} catch (JSONException e) {
				e.printStackTrace();
			}
			if(jsonObject != null){
				Account tempAccount = gson.fromJson(jsonObject.toString(), Account.class);
				accountList2.add(tempAccount);
			}
		}
		Log.i("accountList2", accountList2.toString());
		
		Account[] accountArrays = new Gson().fromJson(accountArray.toString(), Account[].class);
		for(int i=0;i<accountArrays.length;i++){
			Log.i("accountArrays",accountArrays[i].toString());
		}
		// 转化为List
		List<Account> accountsList = Arrays.asList(accountArrays);
		
		// 更快捷地解析成List
		Type listType = new TypeToken<ArrayList<Account>>(){}.getType();
		ArrayList<Account> accsList = new Gson().fromJson(accountArray.toString(), listType);
		Log.i("accsList",accsList.toString());
		
		// 生成对象嵌套对象的json
		Account account4 = new Account("4", "888888", "传说之美", sdf.format(new Date()));
		Member member = new Member("4", "我是传说");
		String accountStr = gson.toJson(account4);
		String memberStr = gson.toJson(member);
		JSONObject object = null;
		try {
			JSONObject memberObject = new JSONObject(memberStr);
			object = new JSONObject(accountStr);
			object.put("member", memberObject);		
		} catch (JSONException e) {
			e.printStackTrace();
		}
		Log.i("", object.toString());
		
		//解析对象嵌套对象的json
		Account account5 = gson.fromJson(object.toString(), Account.class);
		Log.i("解析对象嵌套对象的json", account5.toString());
		// 这里用isNull来判断是否存在这个object，存在就拿出member的JSONObject
		JSONObject memberObject = null;
		if(!object.isNull("member")){
			try {
				memberObject = object.getJSONObject("member");
			} catch (JSONException e) {
				e.printStackTrace();
			}
		}
		Member member5 = null;
		if(null != memberObject){
			member5 = gson.fromJson(memberObject.toString(), Member.class);
			Log.i("解析对象嵌套对象的json", member5.toString());
		}
		
		try {
			JSONObject mObject = new JSONObject(memberStr);
			object = new JSONObject(accountStr);
			object.put("memberObject", mObject);		
		} catch (JSONException e) {
			e.printStackTrace();
		}
		AccountObject accountObject = gson.fromJson(object.toString(), AccountObject.class);
		Log.i("accountObject", accountObject.toString());
	}

}
